normalize_plane_equation:
 movups xmm0,[plane_equation]	 ;normalize
 movaps xmm1,xmm0
; andps  xmm0,[zero_hgst_dd]
 mulps	xmm0,xmm0
 haddps xmm0,xmm0
 haddps xmm0,xmm0
; shufps xmm0,xmm0,00000000b
 rsqrtps xmm0,xmm0
 mulps	xmm1,xmm0     ; xmm1 - normalized plane equat.
 movups [plane_equation],xmm1
ret



calc_shadow:  ; calc shadow 4X4 matrix
 ; in esi -> light vector - ptr to 3 dwords float
 ;    ebx -> ptr to 4x4 shadow matrix 16 dwords, 64 bytes
 movups xmm1,[plane_equation]
 movups xmm0,[esi]
 andps	xmm0,[zero_hgst_dd]
 orps	xmm0,[one_hgst_dd]
 movaps xmm2,xmm0  ; xmm2 light vector
 mulps	xmm0,xmm1
 haddps xmm0,xmm0
 haddps xmm0,xmm0
 movaps xmm4,xmm0  ; xmm4 - dot product

 ; do 4x4 shadow matrix
if 1
 movss	xmm3,[plane_equation]
 shufps xmm3,xmm3,0
 mulps	xmm3,xmm2
 movups [ebx],xmm3
 addss	xmm3,xmm4
 movss	[ebx],xmm3

 movss	xmm3,[plane_equation+4]
 shufps xmm3,xmm3,0
 mulps	xmm3,xmm2
 movups [ebx+16],xmm3
 shufps xmm3,xmm3,11100001b
 addss	xmm3,xmm4
 movss	[ebx+20],xmm3

 movss	xmm3,[plane_equation+8]
 shufps xmm3,xmm3,0
 mulps	xmm3,xmm2
 movups [ebx+32],xmm3
 shufps xmm3,xmm3,11000110b
 addss	xmm3,xmm4
 movss	[ebx+40],xmm3

 movss	xmm3,[plane_equation+12]
 shufps xmm3,xmm3,0
 mulps	xmm3,xmm2
 movups [ebx+48],xmm3
 shufps xmm3,xmm3,00100111b
 addss	xmm3,xmm4
 movss	[ebx+60],xmm3	   ; finaly matrix done
end if
if 0
 movss	xmm3,[esi]  ;plane_equation]
; andps  xmm3,[zero_hgst_dd]
; orps	 xmm3,[one_hgst_dd]
 movups  xmm2,[plane_equation]
 shufps xmm3,xmm3,0
 mulps	xmm3,xmm2
 movups [ebx],xmm3
 addss	xmm3,xmm4
 movss	[ebx],xmm3

 movss	xmm3,[esi+4] ;[plane_equation+4]
 shufps xmm3,xmm3,0
 mulps	xmm3,xmm2
 movups [ebx+16],xmm3
 shufps xmm3,xmm3,11100001b
 addss	xmm3,xmm4
 movss	[ebx+20],xmm3

 movss	xmm3,[esi+8] ;[plane_equation+8]
 shufps xmm3,xmm3,0
 mulps	xmm3,xmm2
 movups [ebx+32],xmm3
 shufps xmm3,xmm3,11000110b
 addss	xmm3,xmm4
 movss	[ebx+40],xmm3

 ;movss  xmm3,[f1]  ;;ation+12]
 ;shufps xmm3,xmm3,0
 ;mulps  xmm3,xmm2
 movups [ebx+48],xmm2
 shufps xmm2,xmm2,00100111b
 addss	xmm2,xmm4
 movss	[ebx+60],xmm2	   ; finaly matrix done
end if


ret
if 0
calc_p_light_coords:
; in   - none
; out  - xmm1 -> light position
; uses - edx, xmm0, xmm1, xmm3
    movups   xmm0,[point_light]   ;	calculate light coords.
    movzx    edx,[xres_var]
    cvtsi2ss xmm1,edx
    shufps   xmm1,xmm1,11000000b
    mulps    xmm1,xmm0

    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    subps    xmm1,xmm3
  ;  addps    xmm1,xmm1      ; xmm1 - first point light position
    movups   [point_light_coords],xmm1
ret
end if
xy_in_rect:
 ; in:
 ; eax - current y shl 16 + x
 ; ecx - y1 shl 16 + x1
 ; edx - y2 shl 16 + x2
 ;out:
 ; ebx = 0 no, ebx = 1 yes


  cmp  ax,cx
  jl   .end_no
  cmp  ax,dx
  jg   .end_no
  ror  eax,16
  ror  ecx,16
  ror  edx,16
  cmp  ax,cx
  jl   .end_no
  cmp  ax,dx
  jg   .end_no
  mov  ebx,0x00000001
  ret
.end_no:
  xor  ebx,ebx
ret

move_texture:
 ;  eax - move x
 ;  ebx - move y
    pushad

    .x	 equ  [ebp-6]
    .y	 equ  [ebp-4]
    mov   ebp,esp
    sub   esp,64
    mov   .x,ax
    mov   .y,bx
    cmp   ebx,0
    je	  .xx
    jl	  .ysub
    mov   eax,ebx
    mov   edx,TEX_X
    mul   edx
    mov   ebx,eax
    shl   ebx,2
    lea   esi,[texmap+ebx]
    lea   edi,[texmap]
    cld
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
    rep   movsd
    jmp   .xx
 .ysub:
    mov   esi,texmap
    add   esi,TEX_X*TEX_Y*4
    mov   edi,esi
    neg   ebx
    mov   eax,TEX_X
    mul   ebx
    lea   ecx,[eax*4]
    sub   esi,ecx
    std
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
    rep   movsd
  .xx:

    cmp   word .x,0
    je	  .end
    jl	  .xadd
    movzx eax,word .x
 ;   neg   eax
    lea   edx,[eax*4]
    cld
    xor   ebx,ebx
    lea   esi,[texmap+edx]
    lea   edi,[texmap]
  .next_xsub_l:
    mov   ecx,TEX_X
    sub   ecx,eax
    rep   movsd

    add   esi,edx
    add   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .next_xsub_l
    jmp   .end

   .xadd:

    movsx eax, word .x
    neg   eax

    lea   edx,[eax*4]
    std
    xor   ebx,ebx
    lea   esi,[texmap+TEX_X*TEX_Y*4]
    mov   edi,esi
    sub   esi,edx
  @@:
; .nextxadd_l:
    mov   ecx,TEX_X
    sub   ecx,eax
    rep   movsd
    sub   esi,edx
    sub   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   @b  ;.nextxadd_l;@b

  .end:
   mov	  esp,ebp
   popad
ret
apply_displacement_from_tex:
.vert1_ptr equ dword[ebp-4]
.vert2_ptr equ dword[ebp-8]
.vert3_ptr equ dword[ebp-12]
	push  ebp
	mov   ebp,esp
	sub   esp,128

	xor   ecx,ecx
      .next_vert:
	push   ecx			; ecx - vertex counter
	mov    ebx,ecx
	imul   ebx,[i12]
	add    ebx,[points_r_ptr]
	movups xmm0,[ebx]
	mov    .vert1_ptr,ebx

	mov    esi,ecx
	mov    eax,ecx
	shl    eax,2
	add    eax,[tex_points_ptr]
	mov    ecx,eax
	movzx  eax,word[eax+2] ; tex y
	mov    edx,TEX_X
	mul    edx
	movzx  ecx,word[ecx]   ; tex x
	add    ecx,eax
	shl    ecx,2
	add    ecx,texmap
	mov    eax,ecx
	mov    ecx,[ecx]
	and    ecx,0x00ffffff
	cmp    ecx,0x00ffffff
	je     @f  ; no change if transparent - white color
	movzx  ecx,byte[eax]   ; read R,G,B pixel
	movzx  ebx,byte[eax+1]
	add    ecx,ebx
	movzx  ebx,byte[eax+2]
	add    ecx,ebx



	mov    eax,esi
	imul   eax,[i12]
	add    eax,[points_normals_ptr]
	movups xmm7,[eax]
	cvtsi2ss xmm6,ecx
	cvtsi2ss xmm5,[displac_div]
	divss	 xmm6,xmm5
	shufps	xmm6,xmm6,0
	mulps	xmm7,xmm6
	addps	xmm0,xmm7
	mov	ebx,.vert1_ptr
	movlps	[ebx],xmm0
	movhlps xmm0,xmm0
	movss	[ebx+8],xmm0
      @@:

	pop    ecx
	inc    ecx
	cmp    cx,[points_count_var]
	jnz    .next_vert

	mov    esp,ebp
	pop    ebp

ret

if 0
;triangulize_faces_from_tri_area:
triangulize_all_faces:
; make from triangle in triangulize area 4 triangles
   .new_triangles_ptr  equ dword[ebp-4]
   .new_vertices_ptr   equ dword[ebp-8]
;   .tri_list_counter	equ dword[ebp-12]
   .vert_list_counter  equ dword[ebp-16]
   .index_mid_vert1    equ word[ebp-20]  ; middle edge vertex indexes
   .index_mid_vert2    equ word[ebp-24]
   .index_mid_vert3    equ word[ebp-28]
   .cur_edges_count    equ dword[ebp-32]
   .last_vertex        equ dword[ebp-36]
   .counter_new_tri    equ dword[ebp-40]
   .edges_list_ptr     equ dword[ebp-44]
   .edge123	       equ dword[ebp-48]
   .mx		       equ ebp-84

   push  ebp
   mov	 ebp,esp
   sub	 esp,128

   cmp	 [points_count_var],16000
   jg	 .end
   cmp	 [triangles_count_var],16000
   jg	 .end

   ; mem area pointed by [points_r_ptr]
   ; must have correct size


   movzx   eax,[points_count_var]
   mul	   [i36]
   add	   eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   int3
 @@:
   mov	   .new_vertices_ptr,eax


   mov	  esi,[points_r_ptr]  ; copy vertices to new location
   mov	  edi,eax
   cld
   movzx  ecx,[points_count_var]
   lea	  ecx,[ecx*3]
   rep	  movsd

   mov	   ebx,[points_r_ptr]
   invoke  VirtualFree, ebx , 0, MEM_RELEASE
   or	   eax,eax
   jnz	   @f
   int3
 @@:



   movzx   eax,[triangles_count_var]
   mul	   [i24]
   push    eax
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   int3
 @@:
   mov	   .new_triangles_ptr,eax

   pop	    eax
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	    eax,eax
   jnz	    @f
   int3
  @@:
   mov	    .edges_list_ptr,eax








   movzx     eax,[points_count_var]
   mov	     .vert_list_counter,eax
   mov	     .tri_list_counter,0
   mov	     .cur_edges_count,0
 ;  movzx    ecx,[triangles_count_var]

   xor	     ecx,ecx
   mov	     edi,[triangles_ptr]
 .next_triangle:
   push      ecx
   push      edi

   movzx     edx,word[edi]
   lea	     edx,[edx*3]
   shl	     edx,2
   add	     edx,[points_rotated_ptr]
   movups    xmm0,[edx]
   movaps    xmm1,xmm0
   movlhps   xmm0,xmm0
   cmpnltps  xmm0,dqword[tri_area_x1]
   ; tri_area coords -> float dwords
   pmovmskb  eax,xmm0
   xor	     al,ah
   cmp	     al,0
   jne	     .do_triang

   movzx     edx,word[edi+2]
   lea	     edx,[edx*3]
   shl	     edx,2
   add	     edx,[points_rotated_ptr]
   movups    xmm0,[edx]
   movaps    xmm2,xmm0
   movlhps   xmm0,xmm0
   cmpnltps  xmm0,dqword[tri_area_x1]
   pmovmskb  eax,xmm0
   xor	     al,ah
   cmp	     al,0
   jne	     .do_triang

   movzx     edx,word[edi+4]
   lea	     edx,[edx*3]
   shl	     edx,2
   add	     edx,[points_rotated_ptr]
   movups    xmm0,[edx]
   movaps    xmm3,xmm0
   movlhps   xmm0,xmm0
   cmpnltps  xmm0,dqword[tri_area_x1]
   pmovmskb  eax,xmm0
   xor	     al,ah
   cmp	     al,0
   jne	     .do_triang

   jmp	     .skip_particing


  .do_triang:
   mov	    .edge123,0
  .next_edge:
   mov	    esi,.edges_list_ptr
  ; mov      edx,.cur_edges_count
   xor	    edx,edx
   mov	    eax,dword[edi]  ; first edge
 @@:
   cmp	    [esi],eax
   je	    .edge_found
   ror	    eax,16
   cmp	    [esi],eax
   je	    .edge_found
   add	    esi,6
   inc	    edx
   cmp	    edx,.cur_edges_count
   jng	    @b

  ; calc  mid vertices
   cmp	    .edge123,0
   jne	    @f
   movaps   xmm4,xmm2
   addps    xmm4,xmm1
   jmp	    .next
 @@:
   cmp	    .edge123,1
   jne	    @f
   movaps   xmm4,xmm3
   addps    xmm4,xmm2
   jmp	    .next
 @@:
   movaps  xmm4,xmm1
   addps   xmm4,xmm3

 .next:
   cvtsi2ss xmm5,[i2]
   shufps   xmm5,xmm5,0
   divps    xmm4,xmm5
   mov	    eax,.vert_list_counter
   imul     eax,[i12]
   add	    eax,.new_vertices_ptr
   movups   [eax],xmm4
   add	    .vert_list_counter,1


   ; fill triangles and edges lists
   mov	    eax,.tri_list_counter
   imul     eax,[i6]
   add	    eax,.new_triangles_ptr
   mov	    edx,.vert_list_counter
   push     dword[edi]
   pop	    dword[eax]
   mov	    word[eax+4],dx
   inc	   .tri_list_counter

   mov	    ebx,.cur_edges_count
   imul     ebx,[i6]
   add	    ebx,.edges_list_ptr
   push     dword[edi]
   pop	    dword[ebx]
   mov	    word[ebx+4],dx
   inc	    .cur_edges_count

  .edge_found:
   mov	    eax,.tri_list_counter
   imul     eax,[i6]
   add	    eax,.new_triangles_ptr
   push     dword[edi]
   pop	    dword[eax]
   push     word[esi+4]
   pop	    word[eax+4]
   inc	   .tri_list_counter

   inc	   .edge123
   cmp	   .edge123,3
   jne	   .next_edge
   jmp	   .end_calc_tri

 .skip_particing:
   push    dword[edi]
   mov	   eax,.tri_list_counter
   imul    eax,[i6]
   add	   eax,.new_triangles_ptr	      ;vertices_ptr
   pop	   dword[eax]
   push    word[edi+4]
   pop	   word[eax+4]
   add	   .tri_list_counter,1
 .end_calc_tri:
   pop	  edi
   add	  edi,6
   pop	  ecx
   inc	  ecx
   cmp	  cx,[triangles_count_var]
   jne	  .next_triangle




   invoke  VirtualFree, [triangles_ptr] , 0, MEM_RELEASE
   or	   eax,eax
   jnz	   @f
   int3 	    ; realloc mem fo triangles
 @@:
   mov	    eax,.tri_list_counter
   imul     eax,[i6]
   add	    eax,1024
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	    eax,eax
   jnz	    @f
   int3
  @@:
   mov	    [triangles_ptr],eax

   mov	   eax,.vert_list_counter
   mul	   [i24]
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   int3
 @@:
   mov	   [points_r_ptr],eax


   ; reverse matrix and transform
   ; to point list and triangles list :D
       mov   esi,matrix
       lea   edi,[.mx]
       call  reverse_mx_3x3

       mov   esi,.new_vertices_ptr
       mov   edi,[points_r_ptr]
       lea   ebx,[.mx]
       mov   ecx,.vert_list_counter
       call  rotary


   mov	 eax,.vert_list_counter
   mov	 [points_count_var],ax

   mov	 esi,.new_triangles_ptr
   mov	 edi,[triangles_ptr]
   mov	 ecx,.tri_list_counter
   lea	 ecx,[ecx*3]
   shr	 ecx,1
   inc	 ecx
   rep	 movsd
   mov	 eax,.tri_list_counter
   mov	 [triangles_count_var],ax

   invoke  VirtualFree ,.new_vertices_ptr ,0 , MEM_RELEASE
   invoke  VirtualFree ,.new_triangles_ptr ,0 , MEM_RELEASE
   invoke  VirtualFree ,.edges_list_ptr ,0 , MEM_RELEASE
   invoke  VirtualFree ,[points_rotated_ptr] ,0 , MEM_RELEASE
   mov	   eax,.vert_list_counter
   mul	   [i24]
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   int3
 @@:
   mov	   [points_rotated_ptr],eax

 .end:
   mov	 esp,ebp
   pop	 ebp
ret

end if

if 1
triangulize_all_faces: ; all faces from tri_area_x1, y1, x2, y2
; make from each triangle 4 triangles
   .new_triangles_ptr  equ dword[ebp-4]
   .new_vertices_ptr   equ dword[ebp-8]
   .edges_list_ptr     equ dword[ebp-12]
   .edges_counter      equ dword[ebp-16]
   .index_mid_vert1    equ word[ebp-20]  ; middle edge vertex indexes
   .index_mid_vert2    equ word[ebp-24]
   .index_mid_vert3    equ word[ebp-28]
   .current_edge       equ	[ebp-32]
   .last_vertex        equ dword[ebp-36]
   .counter_new_tri    equ dword[ebp-40]
   .counter_old_tri    equ dword[ebp-44]
   .tri_list_counter   equ dword[ebp-48]


   push  ebp
   mov	 ebp,esp
   sub	 esp,128

   cmp	 [points_count_var],16000
   jg	 .end
   cmp	 [triangles_count_var],16000
   jg	 .end

   ; mem area pointed by [points_r_ptr]
   ; must have correct size


   movzx   eax,[points_count_var]
   mul	   [i36]
   add	   eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   int3
 @@:
   mov	   .new_vertices_ptr,eax

  mov	 esi,[points_rotated_ptr]	 ; copy vertexes to new location
  mov	 edi,eax
  cld
  movzx  ecx,[points_count_var]
  lea	 ecx,[ecx*3]
  rep	 movsd

   mov	   ebx,[points_r_ptr]
   invoke  VirtualFree, ebx , 0, MEM_RELEASE
   or	   eax,eax
   jnz	   @f
   int3
 @@:

   movzx   eax,[points_count_var]	 ; realloc mem fr vertexes
   mul	   [i36]
   add	   eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   int3
 @@:
   mov	   [points_r_ptr],eax


   movzx   eax,[triangles_count_var]
   mul	   [i24]
   push    eax
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	   eax,eax
   jnz	   @f
   int3
 @@:
   mov	   .new_triangles_ptr,eax

   pop	    eax

   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	    eax,eax
   jnz	    @f
   int3
  @@:
   mov	    .edges_list_ptr,eax



   movzx    eax,[points_count_var]
   mov	    .last_vertex,eax
   mov	    .edges_counter,1
   xor	    ecx,ecx
   mov	    .tri_list_counter,0
   mov	    .counter_new_tri,0
   mov	    .counter_old_tri,0

 .next_triangle:
   push     ecx

   mov	    ebx,.counter_old_tri
   add	    ebx,[triangles_ptr]


   movzx     edx,word[ebx]
   lea	     edx,[edx*3]
   shl	     edx,2
   add	     edx, .new_vertices_ptr
   movups    xmm0,[edx]
   movlhps   xmm0,xmm0
   cmpnltps  xmm0,dqword[tri_area_x1]
   ; tri_area coords -> float dwords
   pmovmskb  edx,xmm0
   xor	     dl,dh
   cmp	     dl,0xff
   je	    .do_triang

   movzx     edx,word[ebx+2]
   lea	     edx,[edx*3]
   shl	     edx,2
   add	     edx, .new_vertices_ptr
   movups    xmm0,[edx]
;   movaps    xmm2,xmm0
   movlhps   xmm0,xmm0
   cmpnltps  xmm0,dqword[tri_area_x1]
   pmovmskb  edx,xmm0
   xor	     dl,dh
   cmp	     dl,0xff
   je	    .do_triang

   movzx     edx,word[ebx+4]
   lea	     edx,[edx*3]
   shl	     edx,2
   add	     edx, .new_vertices_ptr
   movups    xmm0,[edx]
;   movaps    xmm3,xmm0
   movlhps   xmm0,xmm0
   cmpnltps  xmm0,dqword[tri_area_x1]
   pmovmskb  edx,xmm0
   xor	     dl,dh
   cmp	     dl,0xff
   je	    .do_triang

   jmp	     .skip_particing



 .do_triang:


   mov	    ebx,[ebx]
   mov	    .current_edge,ebx  ; two indexes of edge
   mov	    edx,ebx  ; edx -> contains cur edge indexes
   mov	    ecx,.edges_counter	     ; check cur edge in edge list
 @@:
   mov	    ebx,ecx
   imul     ebx,[i6]
   add	    ebx,.edges_list_ptr  ; each edge from list 3 words
				 ; 1, 2 - indexes of edge
				 ; 3 - index of midle point
   cmp	    dword[ebx],edx
   je	    .index1_found      ; second exam
   ror	    edx,16
   cmp	    dword[ebx],edx
   je	    .index1_found
   loop     @b
 .no_edge_check:
   mov	    eax,.last_vertex	 ; last vertex index

   shl	    eax,2
   lea	    eax,[eax*3]
   add	    eax,.new_vertices_ptr  ;.new_vertices_ptr  ; eax - desination of cur mid vert
   movzx    ebx,dx   ; edx - cur edge
   shr	    edx,16
   imul     edx,[i12]
   imul     ebx,[i12]
   add	    edx,.new_vertices_ptr
   add	    ebx,.new_vertices_ptr
   movups   xmm0,[edx]
   movups   xmm1,[ebx]
   subps    xmm0,xmm1
   divps    xmm0,[f2x4]
   addps    xmm0,xmm1
   movups   [eax],xmm0
   mov	    eax,.last_vertex ; last ver index
   mov	    .index_mid_vert1,ax
   mov	    ebx,.edges_counter
   imul     ebx,[i6]
   add	    ebx,.edges_list_ptr
   push     dword .current_edge  ; two indexes
   pop	    dword[ebx]
   mov	    word[ebx+4],ax
   add	    .last_vertex,1
   add	    .edges_counter,1
   jmp	    .calc_2cond_ind
 .index1_found:
   mov	    ax,word[ebx+4]
   mov	    .index_mid_vert1,ax

 .calc_2cond_ind:
   mov	    ebx,.counter_old_tri
   add	    ebx,[triangles_ptr]
   mov	    ebx,[ebx+2]
   mov	    .current_edge,ebx  ; two indxes of second edge

   mov	    ecx,.edges_counter	     ; check cur edge in edge list
 @@:
   mov	    ebx,ecx
   imul     ebx,[i6]
   add	    ebx,.edges_list_ptr  ; each edge from list 3 words
				 ; 1, 2 - indexes of edge
				 ; 3 - index of midle point
   mov	    edx,dword .current_edge   ; contains 2 cur edge indexes
   cmp	    dword[ebx],edx
   je	    .index2_found      ; second exam
   ror	    edx,16
   cmp	    dword[ebx],edx
   je	    .index2_found
   loop     @b
   mov	    eax,.last_vertex	 ; last vertex index

   shl	    eax,2
   lea	    eax,[eax*3]
   add	    eax,.new_vertices_ptr  ;.new_vertices_ptr  ; eax - desination of cur mid vert
   mov	    ebx,.current_edge	   ; two indexes of cur edge
   movzx    edx,bx
   shr	    ebx,16
   imul     edx,[i12]
   imul     ebx,[i12]
   add	    edx,.new_vertices_ptr
   add	    ebx,.new_vertices_ptr
   movups   xmm0,[edx]
   movups   xmm1,[ebx]
   subps    xmm0,xmm1
   divps    xmm0,[f2x4]
   addps    xmm0,xmm1
   movups   [eax],xmm0
 ;  movlps   [eax],xmm0
 ;  movhlps  xmm0,xmm0
 ;  movss    [eax+8],xmm0
   mov	    eax,.last_vertex ; last ver index
   mov	    .index_mid_vert2,ax

   mov	    ebx,.edges_counter
   imul     ebx,[i6]
   add	    ebx,.edges_list_ptr
   push     dword .current_edge  ; two indexes
   pop	    dword[ebx]
   mov	    word[ebx+4],ax

   add	    .last_vertex,1
   add	    .edges_counter,1
   jmp	    .calc_3rd_ind

 .index2_found:
   mov	    ax,word[ebx+4]
   mov	    .index_mid_vert2,ax

 .calc_3rd_ind:

   mov	    ebx,.counter_old_tri
   add	    ebx,[triangles_ptr]
   mov	    ecx,[ebx+2]
   mov	    cx,[ebx]
   mov	    .current_edge,ecx  ; two indxes of 3rd edge
   mov	    edx,ecx  ;word .current_edge   ; contains cur edge indexes
   mov	    ecx,.edges_counter	     ; check cur edge in edge list
 @@:
   mov	    ebx,ecx
   imul     ebx,[i6]
   add	    ebx,.edges_list_ptr  ; each edge from list 3 words
				 ; 1, 2 - indexes of edge
				 ; 3 - index of midle point
 ;  mov      edx,dword .current_edge   ; contains cur edge indexes
   cmp	    dword[ebx],edx
   je	    .index3_found      ; second exam
   ror	    edx,16
   cmp	    dword[ebx],edx
   je	    .index3_found
   loop     @b
   mov	    eax,.last_vertex	 ; last vertex index
   imul     eax,[i12]
   add	    eax,.new_vertices_ptr  ;.new_vertices_ptr  ; eax - desination of cur mid vert
   mov	    ebx,.current_edge	   ; two indexes of cur edge
   movzx    edx,bx
   shr	    ebx,16
   imul     edx,[i12]
   imul     ebx,[i12]
   add	    edx,.new_vertices_ptr
   add	    ebx,.new_vertices_ptr
   movups   xmm0,[edx]
   movups   xmm1,[ebx]
   subps    xmm0,xmm1
   divps    xmm0,[f2x4]
   addps    xmm0,xmm1
   movups   [eax],xmm0
   mov	    eax,.last_vertex ; last ver index
   mov	    .index_mid_vert3,ax

   mov	    ebx,.edges_counter
   imul     ebx,[i6]
   add	    ebx,.edges_list_ptr
   push     dword .current_edge  ; two indexes
   pop	    dword[ebx]
   mov	    word[ebx+4],ax

   add	    .last_vertex,1
   add	    .edges_counter,1
   jmp	    .update_triangles_list
 .index3_found:
   mov	    ax,word[ebx+4]
   mov	    .index_mid_vert3,ax

 .update_triangles_list:

   mov	 ebx,.counter_new_tri
   mov	 esi,.counter_old_tri
 ;  shr   ebx,2
 ;  shr   esi,2
   add	 ebx,.new_triangles_ptr
   add	 esi,[triangles_ptr]


   push  word[esi]
   pop	 word[ebx+2]
   push  .index_mid_vert3
   pop	 word[ebx]
   push  .index_mid_vert1
   pop	 word[ebx+4]

   push  .index_mid_vert1
   pop	 word[ebx+8]
   push  .index_mid_vert2
   pop	 word[ebx+6]
   push  word[esi+2]
   pop	 word[ebx+10]

   push  .index_mid_vert1
   pop	 word[ebx+14]
   push  .index_mid_vert3
   pop	 word[ebx+12]
   push  .index_mid_vert2
   pop	 word[ebx+16]

   push  word[esi+4]
   pop	 word[ebx+20]
   push  .index_mid_vert2
   pop	 word[ebx+18]
   push  .index_mid_vert3
   pop	 word[ebx+22]

   add	   .tri_list_counter,4
   add	 .counter_new_tri,24
   add	 .counter_old_tri,6
   jmp	 .tri_list_done

.skip_particing:
 ;  mov     ebx,.counter_old_tri
 ;  shr     ebx,2
 ;  add     ebx,[triangles_ptr]
   push    word[ebx]
   mov	   eax,.counter_new_tri
 ;  shr     eax,2
   add	   eax,.new_triangles_ptr	      ;vertices_ptr
   pop	   word[eax]
   push    word[ebx+2]
   pop	   word[eax+2]
   push    word[ebx+4]
   pop	   word[eax+4]
   add	   .counter_old_tri,6
   add	   .counter_new_tri,6
   add	   .tri_list_counter,1
 .tri_list_done:
   pop	 ecx
   inc	 ecx
   cmp	 cx,[triangles_count_var]
   jnz	 .next_triangle


   ; end main loop



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; reverse matrix, and transform
;; from new_vertices to points_r
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




   mov	   ebx,[triangles_ptr]
   invoke  VirtualFree, ebx , 0, MEM_RELEASE
   or	   eax,eax
   jnz	   @f
   int3 	    ; realloc mem fo triangles
 @@:


   movzx    eax,[triangles_count_var]
   imul     eax,[i24]
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or	    eax,eax
   jnz	    @f
   int3
  @@:
   mov	    [triangles_ptr],eax

   mov	 esi,.new_triangles_ptr
   mov	 edi,[triangles_ptr]
   cld
   movzx ecx,[triangles_count_var]
   imul  ecx,[i6]
   rep	 movsd




   mov	 ecx,.tri_list_counter
   mov	 [triangles_count_var],cx

   mov	   eax,.last_vertex
   mov	   [points_count_var],ax

; release allocated temp mem

  mov	 esi,.new_vertices_ptr	      ; copy vertexes to new location
  mov	 edi,[points_r_ptr]
  cld
  movzx  ecx,[points_count_var]
  lea	 ecx,[ecx*3]
  rep	 movsd


   mov	   ebx,.new_vertices_ptr
   invoke  VirtualFree, ebx , 0, MEM_RELEASE
   or	   eax,eax
   jnz	   @f
   int3
 @@:

   mov	   ebx,.new_triangles_ptr
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
   int3
 @@:

   mov	   ebx,.edges_list_ptr
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
   int3
 @@:

  .end:
;  mov	 [tp_mem_alloc],1
   mov	 esp,ebp
   pop	 ebp
ret
end if

load_tetrahedron:

    mov   esi,tetra_points_r
    mov   edi,[points_r_ptr]
    cld
    fninit
    mov   ecx,tetra_points_count*3 + 1
  @@:
    rep   movsd
;    fild  word[esi]
;    fstp  dword[edi]
;    add   esi,2
;    add   edi,4
;    loop  @b
;    movsd

    mov   esi,tetra_triangles
    mov   edi,[triangles_ptr]
    mov   ecx,tetra_triangles_count*12 + 2
    rep   movsw


    mov   ecx,tetra_triangles_count * 12 + 1
    mov   esi,tetra_tex_points
    mov   edi,[tex_points_ptr]
    rep   movsd

    mov  [triangles_count_var],tetra_triangles_count
    mov  [points_count_var],tetra_points_count

ret
if 0
load_box:

    mov   esi,box_points
    mov   edi,[points_r_ptr]
    cld
    fninit
    mov   ecx,box_points_count*3
  @@:
    fild  word[esi]
    fstp  dword[edi]
    add   esi,2
    add   edi,4
    loop  @b
    movsd

    mov   esi,box_triangles
    mov   edi,[triangles_ptr]
    mov   ecx,box_triangles_count*3
    cld
    rep   movsw
    movsd


    mov   ecx,box_triangles_count
    inc   ecx
    mov   esi,box_tex_points
    mov   edi,[tex_points_ptr]
    rep   movsd

    mov  [triangles_count_var],box_triangles_count
    mov  [points_count_var],box_points_count
ret
end if
blur_screen:
;blur n times  ; blur or fire
;in - ecx  times count
;.counter equ dword[esp-4]
.counter1 equ dword[esp-8]

	 push	    ebp
	 mov	    ebp,esp
	 movaps     xmm5,[blur_sub]
     .again_blur:
	 push	    ecx
	 mov	    edi,[screen_ptr]
	 movzx	    ecx,[xres_var]  ;SIZE_X
	 xor	    eax,eax
	 rep	    stosd
	 movzx	    ecx,[xres_var]  ;SIZE_X
	 movzx	    ebx,[yres_var]  ;SIZE_X
	 sub	    ebx,4
	 imul	    ecx,ebx
	 shr	    ecx,2
	 movzx	    ebx,[xres_var]  ;SIZE_X
  ;	  mov	     ecx,(SIZE_X*(SIZE_Y-4))*4/16
	 mov	    esi,edi
	 mov	    edx,ebx
	 shl	    edx,2
	 sub	    esi,edx
     .blr:
     @@:
	 movaps     xmm0,[edi+ebx*4]
	 movaps     xmm1,[esi];[edi-ebx*4]
	 movaps     xmm2,[edi-16]
	 movaps     xmm3,[edi+16]

	 pavgb	    xmm0,xmm1
	 pavgb	    xmm2,xmm3
	 pavgb	    xmm0,xmm2

	 psubusb    xmm0,xmm5  ; importand if fire

	 movaps     [edi],xmm0
	 add	    edi,16
	 add	    esi,16

	 loop	    .blr

	 xor	    eax,eax
	 movzx	    ecx,[xres_var] ;SIZE_X
	 rep	    stosd
	 pop	    ecx
	 loop	    .again_blur
	 mov	    esp,ebp
	 pop	    ebp
ret
if 0
	 emms
	 push	    ebp
	 mov	    ebp,esp
	 push	    dword 0x01010101
	 push	    dword 0x01010101
	 movq	    mm4,[esp]
     .again_blur:
	 push	    ecx
	 mov	    edi,buffer
	 mov	    ecx,SIZE_X/4
     ;	  pxor	     mm5,mm5
	 xor	    eax,eax
	 rep	    stosd

	 mov	    ecx,(SIZE_X*(SIZE_Y-4))/8
     .blr:
     @@:
	 movq	    mm0,[edi+SIZE_X*4]
	 movq	    mm1,[edi-SIZE_X*4]
	 movq	    mm2,[edi-4]
	 movq	    mm3,[edi+4]

	 pavgb	    mm0,mm1
	 pavgb	    mm2,mm3
	 pavgb	    mm0,mm2

	 psubusb    mm0,mm4  ; importand if fire

	 movq	    [edi],mm0
	 add	     edi,8
	 add	     esi,8

	 loop	     .blr

	 xor	    eax,eax
	 mov	    ecx,SIZE_X/4
	 rep	    stosd
	 pop	     ecx
	 loop	    .again_blur
	 mov	    esp,ebp
	 pop	    ebp


ret
end if
normalize_object1:  ; procedure don't save registers !!
; out xmm7 - broadcasted reciprocal of maxscale
;     xmm0 - center
	.points_count equ ebp+4
	.points_r     equ ebp+8

     ;	push  ebp
       mov   ebp,esp

       xor    ebx,ebx
       xorps  xmm7,xmm7    ;xmm7 - maxxx, max of all maxes
    .find_again_min_max:
       mov    ecx,[.points_count]
       dec    ecx
       mov    edi,[.points_r]
       movss  xmm0,dword[edi+ebx]
       movss  xmm1,dword[edi+ebx]
     @@:
       maxss  xmm0,dword[edi+ebx+12]	; xmm0 - max
       minss  xmm1,dword[edi+ebx+12]	; xmm1 - min

       add    edi,12
       loop   @b

       addss  xmm0,xmm1 	    ; xmm0 - substraction
       mov    eax,2
       cvtsi2ss xmm2,eax
       divss  xmm0,xmm2 	    ; xmm0 - center
       movss  [center_scale+ebx],xmm0


       mov    edi,[.points_r]
       mov    ecx,[.points_count]
    @@:
       movss  xmm2,[edi+ebx]   ; xmm0 - center
       subss  xmm2,xmm0
       movss  [edi+ebx],xmm2
       maxss  xmm7,xmm2        ; xmm7 - maximum of all
       add    edi,12	       ; cooficientes
       loop   @b
       add    ebx,4
       cmp    ebx,12
       jne    .find_again_min_max

       movss  [max_scale],xmm7
    ;	fninit
    ;	fld    [max_scale]
    ;	fchs
    ;	fstp   [max_scale]


    ;	movss  xmm7,[max_scale]
       mov    edi,[.points_r]
       mov    ecx,[.points_count]
       rcpss  xmm7,xmm7
       shufps xmm7,xmm7,0
     @@:
       movups xmm6,[edi]
       mulps  xmm6,xmm7
       movlps [edi],xmm6
       psrldq xmm6,8
       movss  [edi+8],xmm6
       add    edi,12
       loop   @b

       mov    esp,ebp
     ;	pop    ebp
ret 8
if 0
generate_texture1:		    ; draw heart in texture buffer
       .x1	 equ  ebp-4
       .y1	 equ  ebp-8
       .x2	 equ  ebp-12
       .y2	 equ  ebp-16
       .x3	 equ  ebp-20
       .y3	 equ  ebp-24
       .hrt_scale  equ ebp-28

       push	 ebp
       mov	 ebp,esp
       sub	 esp,128

       mov	 esi,hrt_points
       mov	 edi,hrt_[points_r_ptr]
       mov	 ecx,hrt_points_count
       lea	 ecx,[ecx*3]
       fninit
     @@:
       fild	 word[esi]	 ; convert from integer to float
       fstp	 dword[edi]
       add	 esi,2
       add	 edi,4
       loop	 @b

       pushad
       push   dword hrt_[points_r_ptr]
       push   dword hrt_points_count
       call   normalize_object1
       popad

     mov   eax,0x00ffffff	  ; fill tex buffer
     mov   edi,texmap
     cld
     mov   ecx,TEXTURE_SIZE
     rep   stosd

     mov   dword[.hrt_scale],100.0
     push  [line_buffer_var]		; draw in texmap buffer
     push  [screen_width_var]
     mov   [screen_width_var],TEX_X
     mov   [line_buffer_var],texmap
     xor   ecx,ecx
     fninit
  @@:
     push  ecx
     lea   ecx,[ecx*3]
     lea   esi,[hrt_triangles+ecx*2]

     movzx eax,word[esi]
     lea   eax,[eax*3]
     shl   eax,2
     fld   dword[eax+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd	[tex_x_div2]
   ;  fadd  dword[.hrt_scale]
     fistp dword[.x1]

     fld   dword[eax+4+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd	[tex_x_div2]
;     fadd  dword[.hrt_scale]
     fistp dword[.y1]

     movzx eax,word[esi+2]
     lea   eax,[eax*3]
     shl   eax,2
     fld   dword[eax+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd	[tex_x_div2]
;     fadd  dword[.hrt_scale]
     fistp dword[.x2]

     fld   dword[eax+4+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd	[tex_x_div2]
   ;  fadd  dword[.hrt_scale]
     fistp dword[.y2]


     movzx eax,word[esi+4]
     lea   eax,[eax*3]
     shl   eax,2
     fld   dword[eax+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
    ; fadd  dword[.hrt_scale]
     fiadd	[tex_x_div2]
     fistp dword[.x3]

     fld   dword[eax+4+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd	[tex_x_div2]
;     fadd  dword[.hrt_scale]
     fistp dword[.y3]


     pushad
     mov   eax,[.x1]
     mov   ebx,[.y1]
     mov   ecx,[.x2]
     mov   edx,[.y2]
     and   eax,0x000001ff    ; truncate if exceedes texture area
     and   ebx,0x000001ff
     and   ecx,0x000001ff
     and   edx,0x000001ff
     call  linea
     popad

     pushad
     mov   eax,[.x1]
     mov   ebx,[.y1]
     mov   ecx,[.x3]
     mov   edx,[.y3]
     and   eax,0x000001ff
     and   ebx,0x000001ff
     and   ecx,0x000001ff
     and   edx,0x000001ff
     call  linea
     popad

     pushad
     mov   eax,[.x2]
     mov   ebx,[.y2]
     mov   ecx,[.x3]
     mov   edx,[.y3]
     and   eax,0x000001ff
     and   ebx,0x000001ff
     and   ecx,0x000001ff
     and   edx,0x000001ff
     call  linea
     popad

     pop   ecx
     inc   ecx
     cmp   ecx,hrt_triangles_count
     jne   @b


     pop   [screen_width_var]
     pop   [line_buffer_var]

     mov   esp,ebp
     pop   ebp
ret
end if
generate_texture1:  ; do blank texture uses for smooth objects edges
       mov  edi,texmap
       mov  eax,0xffffffff
       mov  ecx,TEX_X*TEX_Y
       cld
       rep  stosd
ret

generate_texture3:
;pushad
       mov  edi,texmap
       xor  ecx,ecx
       cld
     .next:
       xor  ebx,ebx
     @@:
       mov  eax,ecx
       mov  edx,ebx
       xor  eax,edx
       mov  ah,al
       push ax
       shl  eax,8
       pop  ax
;	or   eax,0x00f00000
       ;mov  [edi],eax
       ;add  edi,4
       stosd
       inc  ebx
       cmp  ebx,TEX_X
       jne  @b
       inc  ecx
       cmp  ecx,TEX_Y
       jne  .next
;popad
ret

generate_texture2:
.const equ 32
	cld
	mov	edi,texmap
	xor	bx,bx
     .next_line:
	xor	dx,dx
     .next2stripes:
	mov	eax,-1
	mov	ecx,(TEX_X/.const)
	rep	stosd
	mov	eax,0x00ff0000
	mov	ecx,(TEX_X/.const)
     @@:
	stosd
	loop	@b
	inc	dx
	cmp	dx,.const/2
	jl	.next2stripes
	inc	bx
	cmp	bx,TEX_Y
	jl	.next_line
ret



calc_bumpmap_coords:	  ; map texture, bump

      fninit
      fldpi
      fadd	st,st
      mov	esi,[points_r_ptr]
      mov	edi,[tex_points_ptr]
      movzx	ecx,[points_count_var]
      inc	ecx

   .again:
      cmp	[map_flag],2
      jg	.spherical
       ; choose map planar or spherical
       ; map flag 1,2,3 - various planar mapping
      cmp      [map_flag],0
      jne      @f
      xor      eax,eax
      mov      ebx,4
      jmp      .do_planar
  @@:
      cmp      [map_flag],1
      jne      @f
      mov      eax,4
      mov      ebx,8
      jmp      .do_planar
  @@:
;      cmp	[map_flag],3
;      jne	@f
      mov      eax,8
      mov      ebx,4
   .do_planar:
   @@:
      fld	dword[esi+eax]
      fimul	[tex_x_div2]   ; planar map
      fiadd	[tex_x_div2]
      fistp	word[edi]

      fld	dword[esi+ebx]
      fimul	[tex_x_div2]
      fiadd	[tex_x_div2]
      fistp	word[edi+2]

      add      esi,12
      add      edi,4
      loop     .do_planar

      jmp	.end
;      cmp	 [map_tex_flag],1
;      jne	 .cylindric
   .spherical:
;
;      cmp	[map_flag],3
;      jne	@f
;      xor	eax,eax
;      mov	ebx,4
;      jmp	.do_sp
;  @@:
;      cmp	[map_flag],4
;      jne	@f
;      mov	eax,4
;      mov	ebx,8
;      jmp	.do_sp
;  @@:
;;	cmp	 [map_flag],3
;;	jne	 @f
;      mov	eax,8
;      mov	ebx,0
;      ; spherical mapping around y axle
;   .do_sp
   @@:
      fld	dword[esi]     ; x coord
      fld	dword[esi+8]   ; z coord
      fpatan		       ; arctg(st1/st)
;      fdiv	 .Pi2
      fdiv	st0,st1
      fimul	[tex_x_div2]
      fiadd	[tex_x_div2]
      fistp	word[edi]      ; x

      fld	dword[esi+4]   ; y coord
      fld	dword[esi]     ; x
      fmul	st,st0
      fld	dword[esi+4]   ; y
      fmul	st,st0
      fld	dword[esi+8]   ; z
      fmul	st,st0
      faddp
      faddp
      fsqrt
      fpatan
      fldpi
      fdivp
      fimul    [tex_y_div2]
      fiadd    [tex_y_div2]
      fistp    word[edi+2]     ; y


      add      esi,12
      add      edi,4
      loop     @b
   .end:
      ffree    st0

ret


calc_bumpmap:		 ; calculate random bumpmap
;--------------in edi _ pointer to TEX_X x TEX_Y bumpmap

	 pushad

	 mov	 edi, bump_map
	 mov	 esi,texmap
	 mov	 ecx,TEXTURE_SIZE
	 cmp	 [bump_flag],0
	 je	 .random_bump_map
	 ; else bumps according to texture
      @@:
	 movzx	 ax,byte[esi]
	 movzx	 bx,byte[esi+1]
	 movzx	 dx,byte[esi+2]
	 add	 ax,bx
	 add	 ax,dx
	 cwd
	 div	 [i3]
	 stosb
	 add	 esi,4
	 loop	 @b
	 jmp	 .blur_map

;	  push	  ecx
;	  mov	  eax,0x88888888
;	  mov	  ecx,16/4
;	  rep	  stosd
;	  mov	  eax,0xffffffff
;	  mov	  ecx,16/4
;	  rep	  stosd
;	  pop	  ecx
;	  loop	  @b
  .random_bump_map:

  ;	  RDTSC
  ;	  mov	 [rand_seed],ax
      @@:
	 push	 ecx
	 xor	 ecx,ecx
	 mov	 edx,255
	 call	 random
	 stosb
	 pop	ecx
	 loop	@b

      .blur_map:

      ;   movzx  ecx,[bumps_deep_flag]
	 mov	edi, bump_map
	 mov	ecx,4
      ;   inc	 cx
      .blur:
	 xor	esi,esi
	 mov	edx,TEXTURE_SIZE
	 xor	eax,eax
	 xor	ebx,ebx
      @@:
	 mov	ebp,esi
	 dec	ebp
	 and	ebp,TEXTURE_SIZE
	 mov	al,byte[ebp+edi]

	 mov	ebp,esi
	 inc	ebp
	 and	ebp,TEXTURE_SIZE
	 mov	bl,byte[ebp+edi]
	 add	eax,ebx

	 mov	ebp,esi
	 sub	ebp,TEX_X
	 and	ebp,TEXTURE_SIZE
	 mov	bl,byte[ebp+edi]
	 add	eax,ebx

	 mov	ebp,esi
	 add	ebp,TEX_X
	 and	ebp,TEXTURE_SIZE
	 mov	bl,byte[ebp+edi]
	 add	eax,ebx

	 shr	eax,2
	 mov	byte[esi+edi],al

	 inc	esi
	 dec	edx
	 jnz	@b

	 loop	.blur
	 popad
ret


make_random_lights:
  .temp1  equ ebp-4
  .temp2  equ ebp-8	;  - light vector generate variables
  .temp3  equ ebp-12
  .max equ 800
	RDTSC
	mov    [rand_seed],ax
	push	ebp
	mov	ebp,esp
	sub	esp,12
	mov	edi,lights
	fninit
	mov	dword[.temp2],.max
	mov	dword[.temp3],.max/2

    .again:
	xor	esi,esi
     @@:
	mov	edx,.max
	xor	ecx,ecx
	call	random
	sub	eax,.max/2
	mov	dword[.temp1],eax
	fild	dword[.temp1]
	fidiv	dword[.temp3]
	fstp	dword[edi+esi*4]
	inc	esi
	cmp	esi,2
	jne	@b

  .max1 equ 1000
	mov	dword[.temp2],.max1/2
	mov	edx,.max1
	xor	ecx,ecx
	call	random
	mov	dword[.temp1],eax
	fild	dword[.temp1]
	fchs
	fidiv	dword[.temp2]
	fstp	dword[edi+8]

	xor	esi,esi
     @@:
	mov	ecx,220 	   ; max colors and shine  , ecx = 200 - more bright shading
	mov	edx,255
	call	random
	movzx	ax,al
	mov	[edi+28+esi*2],ax
	inc	esi
	cmp	esi,4
	jne	@b

	xor	esi,esi
     @@:
	mov	ecx,100 	     ; orginal colors
	movzx	edx,word[edi+28+esi*2]
	call	random
	movzx	ax,al
	mov	[edi+12+esi*2],ax
	inc	esi
	cmp	esi,3
	jne	@b

	xor	esi,esi
     @@:
	mov	ecx,1		    ; min cols
	movzx	edx,word[edi+12+esi*2]
	call	random
	movzx	ax,al
	mov	[edi+20+esi*2],ax
	inc	esi
	cmp	esi,3
	jne	@b

	add	edi,LIGHT_SIZE ;22
	cmp	edi,lightsend
	jne	.again

	mov	esp,ebp
	pop	ebp
ret

random:
;  in  - ecx - min
;	 edx - max
;  out - eax - random number
	 mov	bx,[rand_seed]
	 add	bx,0x9248
	 ror	bx,3
	 mov	[rand_seed],bx

	 mov	ax,dx
	 sub	ax,cx
	 mul	bx
	 mov	ax,dx
	 add	ax,cx
	 cwde
ret

do_color_buffer:	 ; do color buffer for Gouraud, flat shading
;env_map 512 x 512 x 3 bytes	; many lights using
.temp  equ word   [ebp-2]
.nz    equ dword  [ebp-6]  ; dword
.ny    equ dword  [ebp-10]
.nx    equ dword  [ebp-14]
.col_r equ    [ebp-16]
.col_g equ    [ebp-17]
.col_b equ    [ebp-18]

	 push	  ebp
	 mov	  ebp,esp
	 sub	  esp,20
	 mov	  edi,color_map
	 fninit

	 mov	  dx,- TEX_Y / 2 ;-256	 ; dx - vertical coordinate = y
    .ie_ver:
	 mov	  cx,- TEX_X / 2 ;256	; cx - horizontal coord = x
    .ie_hor:
	 mov	  .temp,cx
	 fild	  .temp
	 fidiv	  [tex_x_div2];[i256]st = Nx - vector normal x cooficient
	 fst	  .nx
	 fmul	  st,st0
	 mov	  .temp,dx
	 fild	  .temp
	 fidiv	  [tex_y_div2];[i256]st = Ny - vector normal y coeficient
	 fst	  .ny
	 fmul	  st,st0
	 faddp
	 fld1
	 fchs
	 faddp
	 fabs
	 fsqrt
	 fchs
	 fstp	  .nz		   ; st - Nz - vect normal z coeficient
	 xor	  ebx,ebx
	 mov	  dword .col_b, 0
     .light:
	 push	  edi	;env_map
	 lea	  esi,[lights+ebx]
	 lea	  edi,.nx
	 call	  dot_product
	 pop	  edi
	 fcom	  [dot_min]
	 fstsw	  ax
	 sahf
	 ja	  .env_ok1  ;compare with dot_max
	 ffree	  st

	jmp	  .update_counters
      .env_ok1:
	 fcom	 [dot_max]
	 fstsw	 ax
	 sahf
	 jb	 .env_ok2     ; calc col
	 ffree	 st
	 jmp	 .update_counters
      .env_ok2: 	   ;calc col
	 push	  ebp
	 push	  word[esi+36]	 ; -  shines
	 push	  word[esi+12]	 ; b  orginal color
	 push	  word[esi+14]	 ; g
	 push	  word[esi+16]	 ; r
	 push	  word[esi+28]	 ; b  max color
	 push	  word[esi+30]	 ; g
	 push	  word[esi+32]	 ; r
	 push	  word[esi+20]	 ; b  min col
	 push	  word[esi+22]	 ; g
	 push	  word[esi+24]	 ; r
	 push	  eax	      ; earlier - dot pr
      ;  fstp	  .dot_product
      ;  push	  .dot_product
	 call	  calc_one_col
	 pop	  ebp
	 ; eax-0x00rrggbb
	 cmp	  al,.col_b
	 jbe	  @f
	 mov	  .col_b,al
   @@:
	 shr	  ax,8
	 cmp	  al,.col_g
	 jbe	  @f
	 mov	  .col_g,al
   @@:
	 shr	  eax,16
	 cmp	  al,.col_r
	 jbe	  @f
	 mov	  .col_r,al
  @@:
 .update_counters:				    ; update and jump when neccesery
	add	ebx,LIGHT_SIZE
	cmp	bx,[all_lights_size]
	jl	.light	  ; next_light
	mov	eax,dword .col_b
	stosd

	inc	cx
	cmp	cx,TEX_X / 2 ;256
	jne	.ie_hor

	inc	dx
	cmp	dx,TEX_X / 2 ;256
	jne	.ie_ver

    .env_done:
	 mov	 esp,ebp
	 pop	 ebp
ret




init_envmap2:	      ; do env_map
;env_map 512 x 512 x 4 bytes
.temp  equ word   [ebp-2]
.nEy   equ word   [ebp-4]
.nEx   equ word   [ebp-6]
.col_r equ	  [ebp-8]
.col_g equ	  [ebp-9]
.col_b equ	  [ebp-10]

	 push	  ebp
	 mov	  ebp,esp
	 sub	  esp,20
	 mov	  edi,envmap
	 fninit

	 mov	  dx,- TEX_Y / 2 ;256	; dx - vertical coordinate = y
    .ie_ver:
	 mov	  cx,- TEX_X / 2 ;256	; cx - horizontal coord = x
    .ie_hor:
	 xor	  ebx,ebx
	 mov	  dword .col_b, 0
     .light:
	 lea	  esi,[lights+ebx]
	 fld	  dword[esi]	 ; light vector x cooficient
	 fimul	  [tex_x_div2] ;[i256]
	 mov	  .temp,cx
	 fisubr   .temp
	 fistp	  .nEx
	 fld	  dword[esi+4]	 ; light vector y cooficient
	 fimul	  [tex_y_div2] ;[i256]
	 mov	  .temp,dx
	 fisubr   .temp
	 fistp	  .nEy

	 cmp	  .nEx,- TEX_X / 2 ;256
	 jl	  .update_counters
	 cmp	  .nEy,- TEX_Y / 2 ;256
	 jl	  .update_counters
	 cmp	  .nEx,TEX_X / 2 ;256
	 jg	  .update_counters
	 cmp	  .nEy,TEX_Y / 2 ;256
	 jg	  .update_counters

	 fild	  .nEx
	 fmul	  st,st0
	 fild	  .nEy
	 fmul	  st,st0
	 faddp
	 fsqrt
	 fisubr   [i256]
	 fmul	  [env_const]
	 fidiv	  [i256]   ; st - 'virtual' dot product

	 fcom	  [dot_max]
	 fstsw	  ax
	 sahf
	 jb	  @f
	 ffree	  st
	 fld1	  ;[dot_max]
      @@:
	 fcom	  [dot_min]
	 fstsw	  ax
	 sahf
	 ja	  @f
	 ffree	  st
	 fldz	  ;[dot_min]
      @@:
	 push	  ebp
	 push	  word[esi+36]	 ; -  shines
	 push	  word[esi+12]	 ; b  orginal color
	 push	  word[esi+14]	 ; g
	 push	  word[esi+16]	 ; r
	 push	  word[esi+28]	 ; b  max color
	 push	  word[esi+30]	 ; g
	 push	  word[esi+32]	 ; r
	 push	  word[esi+20]	 ; b  min col
	 push	  word[esi+22]	 ; g
	 push	  word[esi+24]	 ; r
	 push	  eax		 ;    earlier - dot pr
      ;  fstp	  .dot_product
      ;  push	  .dot_product
	 call	  calc_one_col
	 pop	  ebp
	 ; eax-0x00rrggbb
	 cmp	  al,.col_b
	 jbe	  @f
	 mov	  .col_b,al
   @@:			      ;  eax - ggbb00rr
	 shr	  ax,8
	 cmp	  al,.col_g
	 jbe	  @f
	 mov	  .col_g,al
   @@:			      ;  eax - bb0000gg
	 shr	  eax,16
	 cmp	  al,.col_r
	 jbe	  @f
	 mov	  .col_r,al
   @@:
   .update_counters:			 ; update and jump when neccesery
	 add	  ebx,LIGHT_SIZE
	 cmp	  bx,[all_lights_size]
	 jl	  .light    ; next_light
	 mov	  eax,dword .col_b
	 or	   eax,0xff000000
	 stosd
     ;	  dec	   edi

	 inc	  cx
	 cmp	  cx,TEX_X / 2 ;256
	 jne	  .ie_hor

	 inc	  dx
	 cmp	  dx,TEX_Y / 2 ;256
	 jne	 .ie_ver

	 mov	 esp,ebp
	 pop	 ebp
ret


  calc_one_col:
; procedure don't save registers !!!
; in -	 st - dot_product
;	 stack - other parameters
; out - eax - 0x00rrggbb
.dot_prd   equ dword[ebp+4]	      ; dot product   - cos x  - not now
.min_col_r equ word[ebp+8]	      ; minimum color - ambient
.min_col_g equ word[ebp+10]
.min_col_b equ word[ebp+12]
.max_col_r equ word[ebp+14]	      ; maximum color - specular
.max_col_g equ word[ebp+16]
.max_col_b equ word[ebp+18]
.org_col_r equ word[ebp+20]	      ; orginal color - diffuse
.org_col_g equ word[ebp+22]
.org_col_b equ word[ebp+24]
.n	   equ word[ebp+26]	      ; shines - not implemented
.temp	   equ word[ebp-2]
.color_sum_r equ dword[ebp-6]
.color_sum_g equ dword[ebp-10]
.color_sum_b equ dword[ebp-14]
; color = ambient+cos(x)*diffuse+(cos(x)^n)*specular
	 mov	 ebp,esp
	 sub	 esp,14

	 mov	  ax,.min_col_r
	 add	  ax,.max_col_r
	 add	  ax,.org_col_r
	 cwde
	 mov	  .color_sum_r,eax

	 mov	  ax,.min_col_g
	 add	  ax,.max_col_g
	 add	  ax,.org_col_g
	 cwde
	 mov	  .color_sum_g,eax

	 mov	  ax,.min_col_b
	 add	  ax,.max_col_b
	 add	  ax,.org_col_b
	 cwde
	 mov	  .color_sum_b,eax


;	  fld	  .dot_prd
       ;  fild	  .n
       ;  fxch	  st1
       ;  fabs
       ;  fyl2x 		    ;
       ;  f2xm1
       ;  fld1
       ;  faddp        ; st =  dot_product ^ n

	 fld	 st	       ; copy dot pr
	 fmul	 st,st0
	 fmul	 st,st0
	 fmul	 st,st0
	 cmp	 .n,255 	   ; .n = 255 -> spot light
	 jne	 @f
	 fmul	 st,st0
	 fmul	 st,st0
	 fmul	 st,st0
      @@:
	 fld	 st	       ; st0=st1=dot_pr^n, st2=dot_pr
	 fimul	 .max_col_b
	 fild	 .org_col_b
	 fmul	 st,st3
	 faddp		       ; st0=first piece of col, st1=dot_pr^n..
	 fiadd	 .min_col_b
	 fimul	 .max_col_b
	 fidiv	 .color_sum_b
	 fistp	 .temp
	 movzx	 eax,.temp
	 shl	 eax,16

	 fld	 st
	 fimul	 .max_col_g
	 fild	 .org_col_g
	 fmul	 st,st3
	 faddp
	 fiadd	 .min_col_g
	 fimul	 .max_col_g
	 fidiv	 .color_sum_g
	 fistp	 .temp
	 mov	 ax,.temp
	 mov	 ah,al
	 shl	 eax,8

	 fimul	 .max_col_r
	 fild	 .org_col_r
	 fmulp	 st2,st
	 faddp
	 fiadd	 .min_col_r
	 fimul	 .max_col_r
	 fidiv	 .color_sum_r
	 fistp	 .temp
	 mov	 ax,.temp	   ;eax -  0xbbgg00rr
     ;	 mov	 ah,al
	 ror	 eax,16
	 xchg	 al,ah		   ; eax - 0x00rrggbb
	 mov	 esp,ebp
ret 24
